<id>
UpdateSession Update
</id>

<version>
0.5
</version>

<mod info>
What this mod does:
When you update your session, you will be asked where you want to go once your session has been updated.  Some of your choices include going straight to the admin center, going back to the page you were on, etc.
In addition, when you login to the boards, you will be asked where you want to go.
Also, when you attempt to modify your profile and you enter your password for verification, if your session is not valid, it will update your session for you.

Changelog:
From 0.4
Added German Language File
Fixed a bug that caused YaBB not to re-direct when you chose "Go back to BoardIndex" on Update Session.
From 0.3
Added a language file
Replaced the checkbox with a selectbox, so you can choose from a few different options on where to go
Added the functions associated with logging in.
From 0.2
Added a checkbox to allow you to go straight to the Admin Center upon updating your session.
From 0.1
Combined two lines of code to optimize it slightly.

</mod info>

<author>
Curtiss Grymala
</author>

<homepage>
http://dchelp.dcevolution.net/
</homepage>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
	if ($sessionvalid == 0 && !$iamguest) { $yymenu .= qq~$menusep<a href="$scripturl?action=revalidatesession">$img{'sessreval'}</a>~; }
</search for>

<replace>
	if ($sessionvalid == 0 && !$iamguest) { $yymenu .= qq~
		<script language="JavaScript1.2" type="text/javascript">
		<!--
		function returnto(GOTO) {
			GOTO = GOTO.replace(/=/g, "%3d");
			GOTO = GOTO.replace('$scripturl?', '');
			document.return_to.urlref.value = GOTO;
			document.return_to.submit();
		}
		-->
		</script>
		$menusep<form name="return_to" action="$scripturl?action=revalidatesession" method="post"><input type="hidden" name="urlref" value="" /></form><a href="javascript:returnto(document.location.href);">$img{'sessreval'}</a>
		~;
	}
</replace>

<search for>
	if ($iamguest) {
		$yymenu .= qq~$menusep<a href="$scripturl?action=login">$img{'login'}</a>~;
</search for>

<replace>
	if ($iamguest) {
		$yymenu .= qq~
			<script language="JavaScript1.2" type="text/javascript">
			<!--
			function returnto(GOTO) {
				GOTO = GOTO.replace(/=/g, "%3d");
				GOTO = GOTO.replace('$scripturl?', '');
				document.return_to.urlref.value = GOTO;
				document.return_to.submit();
			}
			-->
			</script>
		$menusep<form name="return_to" action="$scripturl?action=login" method="post"><input type="hidden" name="urlref" value="" /></form><a href="javascript:returnto(document.location.href);">$img{'login'}</a>
			~;
</replace>

<edit file>
Sources/greetplus.pl
</edit file>

<search for>
sub greet_reg_disable {
	if (!$iamguest) {
		if ($myhour < 12) { $greet_message = qq~$greettxt{'1'}~; }
		elsif ($myhour < 17) { $greet_message = qq~$greettxt{'2'}~; }
		else { $greet_message = qq~$greettxt{'3'}~; }
		&get_bday;
		if ($isbday eq "yes" ){$greet_message = $greettxt{'4'};}
	} else {
		$greet_message = "$maintxt{'248'}";
	}
	$yyuname = $iamguest ? qq~$maintxt{'248'} $maintxt{'28'}. $maintxt{'249'} <a href="$scripturl?action=login">$maintxt{'34'}</a>.~ : qq~$greet_message $realname, ~;
}

sub greet_reg_enable {
	if (!$iamguest) {
		if ($myhour < 12) { $greet_message = qq~$greettxt{'1'}~; }
		elsif ($myhour < 17) { $greet_message = qq~$greettxt{'2'}~; }
		else { $greet_message = qq~$greettxt{'3'}~; }
		&get_bday;
		if ($isbday eq "yes" ){$greet_message = $greettxt{'4'};}
	} else {
		$greet_message = "$maintxt{'248'}";
	}
	$yyuname = $iamguest ? qq~$maintxt{'248'} $maintxt{'28'}. $maintxt{'249'} <a href="$scripturl?action=login">$maintxt{'34'}</a> $maintxt{'377'} <a href="$scripturl?action=register">$maintxt{'97'}</a>.~ : qq~$greet_message $realname, ~;
}
</search for>

<replace>
sub greet_reg_disable {
	if (!$iamguest) {
		if ($myhour < 12) { $greet_message = qq~$greettxt{'1'}~; }
		elsif ($myhour < 17) { $greet_message = qq~$greettxt{'2'}~; }
		else { $greet_message = qq~$greettxt{'3'}~; }
		&get_bday;
		if ($isbday eq "yes" ){$greet_message = $greettxt{'4'};}
	} else {
		$greet_message = "$maintxt{'248'}";
	}
	$yyuname = $iamguest ? qq~$maintxt{'248'} $maintxt{'28'}. $maintxt{'249'} <a href="javascript:returnto(document.location.href);">$maintxt{'34'}</a>.~ : qq~$greet_message $realname, ~;
}

sub greet_reg_enable {
	if (!$iamguest) {
		if ($myhour < 12) { $greet_message = qq~$greettxt{'1'}~; }
		elsif ($myhour < 17) { $greet_message = qq~$greettxt{'2'}~; }
		else { $greet_message = qq~$greettxt{'3'}~; }
		&get_bday;
		if ($isbday eq "yes" ){$greet_message = $greettxt{'4'};}
	} else {
		$greet_message = "$maintxt{'248'}";
	}
	$yyuname = $iamguest ? qq~$maintxt{'248'} $maintxt{'28'}. $maintxt{'249'} <a href="javascript:returnto(document.location.href);">$maintxt{'34'}</a> $maintxt{'377'} <a href="$scripturl?action=register">$maintxt{'97'}</a>.~ : qq~$greet_message $realname, ~;
}
</replace>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'vote',"Poll.pl&DoVote",
</search for>

<add after>
'revalProfSession',"Profile.pl&RevalProfileSession",
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
LoadLanguage("Profile");
</search for>

<add after>
LoadLanguage("UpdateSession");
</add after>

<search for>
	if ($user eq $username) {
		if (&encode_password($new_pass) ne ${$uid.$user}{'password'}) {
			&fatal_error("$profile_txt{'822'}");
		}
	}

	if (($iamadmin || ($iamgmod && $allow_gmod_profile))) {
		if (&encode_password($new_pass) ne ${$uid.$username}{'password'}) {
			&fatal_error("$profile_txt{'897'}");
		}
	}
</search for>

<replace>
	if ($user eq $username) {
		if($new_pass) {
			if (&encode_password($new_pass) ne ${$uid.$user}{'password'}) {
				&fatal_error("$profile_txt{'822'}");
			}
		}
		else {
			if ($INFO{'password'} ne ${$uid.$user}{'password'}) {
				&fatal_error("$profile_txt{'822'}");
			}
		}
	}

	if (($iamadmin || ($iamgmod && $allow_gmod_profile))) {
		if($new_pass) {
			if (&encode_password($new_pass) ne ${$uid.$username}{'password'}) {
				&fatal_error("$profile_txt{'897'}");
			}
		}
		else {
			if ($INFO{'password'} ne ${$uid.$username}{'password'}) {
				&fatal_error("$profile_txt{'822'}");
			}
		}
	}
</replace>

<search for>
	$yytitle = "$profile_txt{'900'}";
	&template;
}

</search for>

<add after>
sub RevalProfileSession {
	$FORM{'cookielength'}   = 360;
	$FORM{'cookieneverexp'} = 1;
		$question = ${$uid.$username}{'password'};
		$answer   = &encode_password("$FORM{'passwrd'}");
		chomp $answer;
	if ($answer ne $question) {
		&UpdateCookie("delete");

		$username           = 'Guest';
		$iamguest           = '1';
		$iamadmin           = '';
		$iamgmod            = '';
		$password           = '';
		@settings           = ();
		@immessages         = ();
		$yyim               = "";
		$realname           = '';
		$realemail          = '';
		$ENV{'HTTP_COOKIE'} = '';
		$yyuname            = "";
		require "$sourcedir/LogInOut.pl";
		$sharedLogin_text = qq~$session_txt{'6'}~;
		$action           = "login";
		&Login;
	} else {
		$realname     = ${$uid.$username}{'realname'};
		$realemail    = ${$uid.$username}{'email'};
		$iamadmin     = ${$uid.$username}{'position'} eq 'Administrator' ? 1 : 0;
		$iamgmod      = ${$uid.$username}{'position'} eq 'Global Moderator' ? 1 : 0;
		$sessionvalid = 1;
	}
	if ($FORM{'cookielength'} < 1 || $FORM{'cookielength'} > 9999) { $FORM{'cookielength'} = $Cookie_Length; }
	if (!$FORM{'cookieneverexp'}) { $ck{'len'} = "\+$FORM{'cookielength'}m"; }
	else { $ck{'len'} = 'Sunday, 17-Jan-2038 00:00:00 GMT'; }
	${$uid.$username}{'session'} = &encode_password($user_ip);
	chomp ${$uid.$username}{'session'};
	&UserAccount($username, "update");
	&UpdateCookie("write", $username, ${$uid.$username}{'password'}, ${$uid.$username}{'session'}, "/", $ck{'len'});

	&WriteLog;
	$yySetLocation = qq~$scripturl?action=profileCheck2;username=$INFO{'username'};password=$answer~;
	&redirectexit;
}

</add after>

<search for>
        <form action="$scripturl?action=profileCheck2;username=$INFO{'username'}" method="post">
</search for>

<replace>
~;
if($sessionvalid == 0) {		
$yymain .= qq~
        <form action="$scripturl?action=revalProfSession;username=$INFO{'username'}" method="post">
~;
}
else {
$yymain .= qq~
        <form action="$scripturl?action=profileCheck2;username=$INFO{'username'}" method="post">
~;
}
$yymain .= qq~
</replace>

<edit file>
Sources/LogInOut.pl
</edit file>

<search for>
LoadLanguage("LogInOut");
</search for>

<add after>
LoadLanguage("UpdateSession");
</add after>

<search for>
        <form action="$scripturl?action=login2" method="post">
</search for>

<add after>
~;
$urlref = $FORM{'urlref'};
$urlref =~ s/=/%3d/g;
$sharedlog .= qq~
<input type="hidden" name="returnto_url" value="$urlref" />
</add after>

<search for>
	&WriteLog;
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
</search for>

<replace>
	&WriteLog;
	if($FORM{'returnto_url'}) {
			$returnto_url = $FORM{'returnto_url'};
			$returnto_url =~ s/%3d/=/g;
	}
	if($FORM{'ses_admin'} == 1) { # 1 = Go back to the page you were viewing #
		if($FORM{'returnto_url'}) {
			$yySetLocation = qq~$scripturl?$returnto_url~;
		}
		else {
			$yySetLocation = qq~$scripturl~;
		}
	}
	elsif($FORM{'ses_admin'} == 2) { # 2 = Go to your profile #
		$yySetLocation = qq~$scripturl?action=viewprofile;username=$username~;
	}
	elsif($FORM{'ses_admin'} == 3) { # 3 = Reply to topic you were viewing #
		$yySetLocation = qq~$scripturl?action=post;$returnto_url;title=PostReply~;
	}
	elsif($FORM{'ses_admin'} == 4) { # 4 = Start a new topic in the board you were viewing #
		$yySetLocation = qq~$scripturl?$returnto_url;action=post;title=StartNewTopic~;
	}
	else {
		$yySetLocation = qq~$scripturl~;
	} 
	&redirectexit;
</replace>

<search for>
		<div style="clear: both; margin-top: 5px; margin-left: auto; margin-right: auto; width: 370px;">
			<span style="float: left; width: 49%; margin-bottom: 5px;">
				<input type="submit" value="$loginout_txt{'34'}" tabindex="5" accesskey="l" style="float: left; width: 175px;" />
</search for>

<add before>
		<div style="clear: both; margin-top: 5px; margin-left: auto; margin-right: auto; width: 370px;">
			<span style="float:left; width: 29%; margin-bottom: 5px;text-align: left;">
				$updateses_txt{'1'}
			</span>
			<span style="float:left; width: 69%; margin-bottom: 5px;">
				<select name="ses_admin" id="ses_admin" tabindex="5">
					<option value="0">$updateses_txt{'5'}</option>
					<option value="2">$updateses_txt{'4'}</option>~;
	if($urlref) {
		$sharedlog .= qq~
					<option value="1">$updateses_txt{'2'}</option>~;
	}
	if( $urlref=~/^num%3d.+/ ) {
		$sharedlog .= qq~
					<option value="3">$updateses_txt{'6'}</option>~;
	}
	if( $urlref=~/^board%3d.+/ ) {
		$sharedlog .= qq~
					<option value="4">$updateses_txt{'7'}</option>~;
	}
	$sharedlog .= qq~
				</select>
			</span>
		</div>
</add before>

<search for>
				<input type="submit" value="$loginout_txt{'34'}" tabindex="5" accesskey="l" style="float: left; width: 175px;" />
</search for>

<replace>
				<input type="submit" value="$loginout_txt{'34'}" tabindex="6" accesskey="l" style="float: left; width: 175px;" />
</replace>

<edit file>
Sources/Sessions.pl
</edit file>

<search for>
LoadLanguage("Sessions");
</search for>

<add after>
LoadLanguage("UpdateSession");
</add after>

<search for>
<form action="$scripturl?action=revalidatesession2" method="post" name="form">
</search for>

<add after>
~;
$urlref = $FORM{'urlref'};
$urlref =~ s/=/%3d/g;
$yymain .= qq~
<input type="hidden" name="returnto_url" value="$urlref" />
</add after>

<search for>
	$yySetLocation = qq~$scripturl~;
</search for>

<replace>
if($FORM{'ses_admin'} == 0) {
	$yySetLocation = qq~$scripturl~;
}
elsif($FORM{'ses_admin'} == 1) {
	$yySetLocation = qq~$boardurl/AdminIndex.$yyaext~;
}
elsif($FORM{'ses_admin'} == 2) {
	if($FORM{'returnto_url'}) {
		$returnto_url = $FORM{'returnto_url'};
		$returnto_url =~ s/%3d/=/g;
		$yySetLocation = qq~$scripturl?$returnto_url~;
	}
	else {
		$yySetLocation = qq~$scripturl~;
	}
}
elsif($FORM{'ses_admin'} == 3) {
	$yySetLocation = qq~$scripturl?action=viewprofile;username=$username~;
}

</replace>

<search for>
      </tr><tr>
        <td align="right" class="windowbg"><b>$sesquest_txt{$sesquestion}:</b></td>
        <td align="left" class="windowbg"><input type="$sestype" name="sesanswer" size="20" tabindex="1" /></td>
      </tr><tr>
</search for>

<add after>
~;
if(${$uid.$username}{'position'} eq 'Administrator' || ${$uid.$username}{'position'} eq 'Global Moderator') {
LoadLanguage("Admin");
$yymain .= qq~
		  <td align="right" class="windowbg"><label for="ses_admin">$updateses_txt{'1'}</label></td>
		  <td align="left" class="windowbg">
		  	<select name="ses_admin" id="ses_admin" tabindex="2">
		  		<option value="0">$updateses_txt{'5'}</option>
		  		<option value="2">$updateses_txt{'2'}</option>
		  		<option value="1">$updateses_txt{'3'}</option>
		  		<option value="3">$updateses_txt{'4'}</option>
		  	</select>
		  </td>
		</tr><tr>~;
}
$yymain .= qq~
</add after>

<search for>
        <td align="center" colspan="2" class="windowbg"><br /><input type="submit" value="$img_txt{'34a'}" tabindex="2" /></td>
</search for>

<replace>
        <td align="center" colspan="2" class="windowbg"><br /><input type="submit" value="$img_txt{'34a'}" tabindex="3" /></td>
</replace>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$updatesession_update_mod = "UpdateSession Update|<a href=\"http://forums.dcevolution.net/\" target=\"_blank\">Curtiss Grymala</a>|Updates the Update Session and Login functions.  When you update your session or log in, you can choose where you want to go after submitting that form.|0.5|July 26, 2006";
	push (@installed_mods, "$updatesession_update_mod");
</add before>